// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'msDBTreeView.pas' rev: 5.00

#ifndef msDBTreeViewHPP
#define msDBTreeViewHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <ImgList.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Commctrl.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Msdbtreeview
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TComponentAction)(System::TObject* Sender);

typedef void __fastcall (__closure *TNodeAction)(System::TObject* Sender, int _type, bool &Confirm);
	

typedef void __fastcall (__closure *TSelectNode)(System::TObject* Sender, Comctrls::TTreeNode* Node)
	;

struct TNodeParams;
typedef TNodeParams *PNodeParams;

struct TNodeParams
{
	int ID;
	int _type;
} ;

class DELPHICLASS TIconIndexes;
class PASCALIMPLEMENTATION TIconIndexes : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FRoot_ImageIndex;
	int FFolder_ImageIndex;
	int FRecord_ImageIndex;
	
__published:
	__property int Root_ImageIndex = {read=FRoot_ImageIndex, write=FRoot_ImageIndex, default=0};
	__property int Folder_ImageIndex = {read=FFolder_ImageIndex, write=FFolder_ImageIndex, default=1};
	__property int Record_ImageIndex = {read=FRecord_ImageIndex, write=FRecord_ImageIndex, default=2};
public:
		
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIconIndexes(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TIconIndexes(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TmsDBTreeView;
class PASCALIMPLEMENTATION TmsDBTreeView : public Comctrls::TCustomTreeView 
{
	typedef Comctrls::TCustomTreeView inherited;
	
private:
	bool FActive;
	bool FInit;
	bool FDeleteNode;
	bool FLocate;
	int FTypeOfSelected;
	TIconIndexes* FIconIndexes;
	Db::TDataSet* FDataSet;
	TNodeAction FOnBeforeAddNode;
	TNodeAction FOnBeforeDelNode;
	TComponentAction FOnBeforeOpen;
	TComponentAction FOnAfterClose;
	TSelectNode FOnSelectNode;
	int __fastcall GetIconIndex(const int _type);
	int __fastcall GetNodeType(void * Data);
	void __fastcall SetFilter(const AnsiString Query);
	void __fastcall Locate_Node(const int ID);
	void __fastcall Locate_Selected(void);
	Comctrls::TTreeNode* __fastcall GetNodeAtID(const int ID);
	void __fastcall InitData(void);
	void __fastcall SaveData(const int SavingField, void * Value);
	
protected:
	virtual void __fastcall SetActive(bool Value);
	virtual void __fastcall SetDataSet(Db::TDataSet* Value);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	DYNAMIC void __fastcall Expand(Comctrls::TTreeNode* Node);
	DYNAMIC void __fastcall Collapse(Comctrls::TTreeNode* Node);
	DYNAMIC void __fastcall Change(Comctrls::TTreeNode* Node);
	void __fastcall Compare(System::TObject* Sender, Comctrls::TTreeNode* Node1, Comctrls::TTreeNode* Node2
		, int Data, int &Compare);
	DYNAMIC void __fastcall Delete(Comctrls::TTreeNode* Node);
	DYNAMIC void __fastcall DragOver(System::TObject* Source, int X, int Y, Controls::TDragState State, 
		bool &Accept);
	DYNAMIC void __fastcall DoEndDrag(System::TObject* Source, int X, int Y);
	DYNAMIC void __fastcall Edit(const tagTVITEMA &Item);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall DoBeforeAddNode(int _type, bool &Confirm);
	DYNAMIC void __fastcall DoBeforeDelNode(int _type, bool &Confirm);
	DYNAMIC void __fastcall DoBeforeOpen(void);
	DYNAMIC void __fastcall DoAfterClose(void);
	DYNAMIC void __fastcall DoSelectNode(Comctrls::TTreeNode* Node);
	
public:
	__fastcall virtual TmsDBTreeView(Classes::TComponent* Owner);
	__fastcall virtual ~TmsDBTreeView(void);
	virtual void __fastcall Open(void);
	virtual void __fastcall Reopen(void);
	virtual void __fastcall Close(void);
	virtual void __fastcall AddNode(const int _type);
	virtual void __fastcall DelNode(void);
	__property bool Active = {read=FActive, write=SetActive, nodefault};
	__property int TypeOfSelected = {read=FTypeOfSelected, nodefault};
	__property Items ;
	
__published:
	__property Db::TDataSet* DataSet = {read=FDataSet, write=SetDataSet};
	__property TIconIndexes* IconIndexes = {read=FIconIndexes, write=FIconIndexes};
	__property TNodeAction OnBeforeAddNode = {read=FOnBeforeAddNode, write=FOnBeforeAddNode};
	__property TNodeAction OnBeforeDelNode = {read=FOnBeforeDelNode, write=FOnBeforeDelNode};
	__property TComponentAction OnBeforeOpen = {read=FOnBeforeOpen, write=FOnBeforeOpen};
	__property TComponentAction OnAfterClose = {read=FOnAfterClose, write=FOnAfterClose};
	__property TSelectNode OnSelectNode = {read=FOnSelectNode, write=FOnSelectNode};
	__property Align ;
	__property Anchors ;
	__property BiDiMode ;
	__property BorderStyle ;
	__property BorderWidth ;
	__property ChangeDelay ;
	__property Color ;
	__property Ctl3D ;
	__property Constraints ;
	__property DragCursor ;
	__property Enabled ;
	__property Font ;
	__property Images ;
	__property Indent ;
	__property ParentBiDiMode ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ReadOnly ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property ToolTips ;
	__property Visible ;
	__property OnAdvancedCustomDraw ;
	__property OnAdvancedCustomDrawItem ;
	__property OnChange ;
	__property OnChanging ;
	__property OnClick ;
	__property OnCollapsed ;
	__property OnCollapsing ;
	__property OnContextPopup ;
	__property OnCustomDraw ;
	__property OnCustomDrawItem ;
	__property OnDblClick ;
	__property OnDeletion ;
	__property OnEdited ;
	__property OnEditing ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnExpanding ;
	__property OnExpanded ;
	__property OnGetImageIndex ;
	__property OnGetSelectedIndex ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TmsDBTreeView(HWND ParentWindow) : Comctrls::TCustomTreeView(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint FIELD_OwnerID = 0x0;
static const Shortint FIELD_State = 0x1;
static const Shortint FIELD_Title = 0x2;
static const Shortint FOLDER_TypeOfNode = 0x0;
static const Shortint RECORD_TypeOfNode = 0x1;
#define RES_WRN_DATASET_CLOSED "Cannot open data, because the DataSet is closed!"
#define RES_WRN_DATASET_NOTFOUND "Cannot open data, because the DataSet is empty!"
#define RES_WRN_ROOTNODE_CANNOTDEL "The root folder cannot be deleted!"

}	/* namespace Msdbtreeview */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Msdbtreeview;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// msDBTreeView
